<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>NumericType - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="EnumType.html">EnumType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="EnumType.html#getInterpolatedValue">getInterpolatedValue</a></li></ul></li><li><a href="ListType.html">ListType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ListType.html#cost">cost</a></li></ul></li><li><a href="MidiType.html">MidiType</a><ul class='members'></ul></li><li><a href="ModalType.html">ModalType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ModalType.html#getPi">getPi</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getNu">getNu</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getTau">getTau</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getRho">getRho</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getOp">getOp</a></li></ul></li><li><a href="NumericType.html">NumericType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="NumericType.html#getNormalized">getNormalized</a></li></ul></li><li><a href="QLearner.html">QLearner</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="QLearner.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#getQtable">getQtable</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doAction">doAction</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doNext">doNext</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doPath">doPath</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#.newQLearner">newQLearner</a></li></ul></li><li><a href="RecordType.html">RecordType</a><ul class='members'></ul></li><li><a href="ScalarField.html">ScalarField</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ScalarField.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#set">set</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#erase">erase</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#add">add</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#load">load</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#save">save</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getValues">getValues</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#has">has</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#get">get</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getExtrapolations">getExtrapolations</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getBarycenter">getBarycenter</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getDiameter">getDiameter</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getDistance">getDistance</a></li></ul></li><li><a href="SetType.html">SetType</a><ul class='members'></ul></li><li><a href="StringType.html">StringType</a><ul class='members'></ul></li><li><a href="SvgType.html">SvgType</a><ul class='members'></ul></li><li><a href="Trajectory.html">Trajectory</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Trajectory.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#addPoint">addPoint</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#addRegion">addRegion</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#add">add</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#getNext">getNext</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#isDone">isDone</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#getPath">getPath</a></li></ul></li><li><a href="Type.html">Type</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Type.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="Type.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="Type.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="Type.html#getCheckMessage">getCheckMessage</a></li><li data-type='method' style='display: none;'><a href="Type.html#getDistance">getDistance</a></li><li data-type='method' style='display: none;'><a href="Type.html#getPath">getPath</a></li><li data-type='method' style='display: none;'><a href="Type.html#compare">compare</a></li><li data-type='method' style='display: none;'><a href="Type.html#getBound">getBound</a></li><li data-type='method' style='display: none;'><a href="Type.html#getBounds">getBounds</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getType">getType</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getTypeNames">getTypeNames</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getTypeParameters">getTypeParameters</a></li><li data-type='method' style='display: none;'><a href="Type.html#.addType">addType</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#json2midi">json2midi</a></li><li><a href="global.html#json2svg">json2svg</a></li><li><a href="global.html#midi2Jon">midi2Jon</a></li><li><a href="global.html#svg2json">svg2json</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">NumericType</h1>
    

    




<section>

<header>
    
        <h2>
        
            NumericType
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="NumericType"><span class="type-signature"></span>new NumericType<span class="signature">(parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Specifies a bounded finite precision numeric value.</p>
<h4><span style='font-size: 180%; font-weight: 400; letter-spacing: -0.01em; margin: 8px 0 3px 0;'>Extends: <a href='./Type.html'>Type</a>.</span> <span style='font-size: 120%; color: #4d4e53;'>This class extends <a href='./Type.html'>Type</a>, with all public methods available.</span></h4>
<p><a name="parameters"></a></p>
<h2>Type parameters</h2>
<h3>General parameter</h3>
<ul>
<li><code>name: ...</code> The type name. By default the type name is &quot;numeric&quot;.</li>
</ul>
<h3>Numeric type meta-data</h3>
<ul>
<li><code>precision: ...</code> The positive numerical precision. Default is <code>NAN</code>, i.e., undefined.
<ul>
<li>This is the value under which two values are indistinguishable.</li>
<li>If <code>precision=1</code> and <code>min</code> and <code>max</code> are integer this means we consider an integer value.</li>
<li>The default means that the value is a constant, not to be adjusted.</li>
</ul>
</li>
<li><code>min: ...</code> The numerical minimal value. Default is <code>-DBL_MAX</code>.</li>
<li><code>max: ...</code> The numerical maximal value. Default is <code>DBL_MAX</code>.</li>
<li><code>zero: ...</code> The numerical default and initial value.
<ul>
<li>This corresponds to the empty value.</li>
<li>The default is <code>(max + min)/2</code>.</li>
</ul>
</li>
<li><code>step: ...</code> The positive sampling step, in order to define a local neighborhood size. Default is <code>NAN</code>, i.e., undefined.
<ul>
<li>It is used to weight the distance calculation.</li>
<li>The default corresponds to a value that is not be sampled.</li>
</ul>
</li>
<li><code>unit: ...</code> The numerical unit name. Defualt is &quot;&quot;, i.e., undefined.</li>
</ul>
<h3>Parameters for the geodesic calculation</h3>
<ul>
<li><code>atomic: ...</code>
<ul>
<li>If true returns only an atomic path with the two left-hand and right-hand elements. Default is true.</li>
<li>If false returns a path with all intermediate values, precision value by precision value if defined.</li>
</ul>
</li>
</ul>
<p><a name="specification"></a></p>
<h2>NumericType specification</h2>
<table class="specification">
<tr style='border: 1px solid black;'><th> Syntactic projection </th><td>
- Returns <tt>NAN</tt> if not a parsable number.
<br/> - Returns the <tt>zero</tt> if an empty value.
</td></tr>
<tr style='border: 1px solid black;'><th> Semantic projection  </th><td>
- If the value is higher than the maximal value or lower than the minimal value it is projected on the related bound.
<br/> - If <tt>precision</tt> is defined the value is projected to the closest <tt>min + k precision</tt> value, <tt>k</tt> being an integer.
</td></tr>
<tr style='border: 1px solid black;'><th> Distance value       </th><td>
The distance is calculated as a weighted value <tt>|lhs-rhs|/step</tt>.
<br/> - It is <tt>INFINITY</tt> if not both object are numeric.
</td></tr>
<tr style='border: 1px solid black;'><th> Geodesic path        </th><td>
The geodesic is assumed to be atomic, i.e. of length 1 if value are equal and 2 if different.
</td></tr>
<tr style='border: 1px solid black;'><th> Comparison           </th><td>
- Returns either <tt>lhs-rhs</tt> or
<br/> <tt>0</tt> if the precision is defined and <tt>|lhs-rhs| < precision</tt>.
</td></tr>
<tr style='border: 1px solid black;'><th> Bounds           </th><td>
- The <tt>min</tt> and <tt>max</tt> values are the obvious bounds, if undefined the empty value is the unique bound.
</td></tr>
</table>
<h2>Note</h2>
<ul>
<li>The numeric parameter values can also be given as a JSON structure, or a String.</li>
<li>The <a href="#getNormalized"><code>getNormalized()</code></a> method allows to map the numerical parameter onto the <code>[-1, 1]</code> interval optionally with <code>zero</code> mapped to <code>0</code>.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            

            

            <td class="description last"><p>The type parameters.</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="getNormalized"><span class="type-signature"></span>getNormalized<span class="signature">(value, with_zero<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns a normalized value given this type.</p>
<ul>
<li>It maps a numerical parameter in the <code>[min, max]</code> range onto the <code>[-1, 1]</code> interval.</li>
<li>If done <code>with_zero</code> the <code>zero</code> mapped to <code>0</code>. Without this option the mapping is linear, while with this option the mapping is a monotonic combination of quadratic profiles, as detailed in the <a href="./numerictype.pdf">related document</a>.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">Value</span>
|

<span class="param-type">double</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The input value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>with_zero</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>true</code>
                
                </td>
            

            <td class="description last"><p>Non-linear normalization to map the <code>zero</code> value on <code>0</code>.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A value in the <code>[-1, 1]</code> range.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2024-03-05 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>